#!/usr/bin/perl

package Exit;

use Exporter;
@ISA = qw(Exporter);
@EXPORT_OK = qw(exit_nicely $OK $ERROR);

$OK    = 0;
$ERROR = 1;

# If the first argument is a hash with the entry 'log',
#   the error message will be appended to the log file.
#   Otherwise, the message will be printed only to STDERR.
sub exit_nicely
{
    my @msg = (@_);

    my $VARS = {};
    my @err_msg = ();
    if ( ref($msg[0]) eq 'HASH' ) 
    {
        $VARS = shift(@msg);
    }

    push @err_msg, "\n\nThe program exited with an error. Backtrace:\n";
    my $i=0;
    while ( (($package, $filename, $line, $subroutine)=caller($i)) )
    {
        push @err_msg, "\t $filename:$line $subroutine\n";
        $i++;
    }
    push @err_msg, "\nThe error was:\n\n",join('',@msg),"\n";
    print STDERR join('',@err_msg);

    if ( defined $VARS->{'log'} )
    {
        if ( !open(LOG,">>$VARS->{log}") )
        {
            print STDERR "$VARS->{log}: $!\n";
        }
        else
        {
            print LOG join('',@err_msg);
            close(LOG);
        }
    }

    exit $ERROR;
}


1;

