#ifndef __CONF_READ_H__
#define __CONF_READ_H__

#define _GNU_SOURCE
#include <stdio.h>
#include <glib.h>

void error(const char *fmt, ...);

GHashTable* conf_read(char *conf);
char  *conf_get_string(GHashTable *conf, char *key, char *default_value);
char  *conf_get_string_or_die(GHashTable *conf, char *key);

int    conf_get_int(GHashTable *conf, char *key, int default_value);
int    conf_get_int_or_die(GHashTable *vals, char *key);

float  conf_get_float(GHashTable *conf, char *key, float default_value);
float  conf_get_float_or_die(GHashTable *conf, char *key);
double conf_get_double(GHashTable *conf, char *key, double default_value);

GList *conf_get_list(GHashTable *conf, char *key, char separator, char *default_value);
GList *conf_get_list_or_die(GHashTable *conf, char *key, char separator);

int conf_is_string_in_list(GHashTable *conf, char *key, char *value);
int conf_is_int_in_list(GHashTable *conf, char *key, int value);    // Beware: Not very fast.
void conf_add_string(GHashTable *conf, char *key, char *val);

#endif

